package ajs.tools;

import ij.*;
import ij.gui.GenericDialog;
import ij.plugin.Duplicator;
import ij.plugin.PlugIn;

public class ZStep_Max implements PlugIn {

	@Override
	public void run(String arg) {
		ImagePlus imp=WindowManager.getCurrentImage();
		ImageStack imst=imp.getStack();
		
		String[] modes=new String[]{"Copy", "Blend", "Average", "Difference", "Transparent-white", "Transparent-zero", "AND", "OR", "XOR", "Add", "Subtract", "Multiply", "Divide", "Min", "Max"};
		int[] modenums=new int[]{0,7,7,8,2,14,9,10,11,3,4,5,6,12,13};

		GenericDialog gd=new GenericDialog("Zstepmax");
		gd.addNumericField("Depth?",3.0,0);
		gd.addCheckbox("Keep original?",false);
		gd.addChoice("Mode",modes,"Max");
		gd.showDialog();
		int depth=(int)gd.getNextNumber();
		boolean keep=gd.getNextBoolean();
		String mode=gd.getNextChoice();
		
		String zsmtitle=imp.getTitle()+"-zstepmax"+depth;
		int modenum=0;
		for(int i=0;i<modes.length;i++) {if(mode.contentEquals(modes[i]))modenum=modenums[i];}
		
		if(keep){
			imp=(new Duplicator()).run(imp);
			imp.show();
		} else {imp.setTitle(zsmtitle);}
		int frms=imp.getNFrames(), sls=imp.getNSlices(), chs=imp.getNChannels();
		for(int fr=0;fr<frms;fr++){
			for(int sl=0;sl<sls;sl++){
				for(int ch=0;ch<chs;ch++){
					for(int n=1;n<depth;n++){
						if(sl+n<sls){
							imst.getProcessor(1+ch+sl*chs+fr*chs*sls).copyBits(imst.getProcessor(1+ch+(sl+n)*chs+fr*chs*sls),0,0,modenum);
							IJ.showProgress((double)(1+ch+sl*chs+fr*chs*sls)/(double)(frms*chs*sls));
						}
					}
				}
			}
		}
		IJ.showProgress(1.0);
		imp.updateAndDraw();
	}

}
